%define major 1
%define libname %mklibname %{name} %{major}
%define develname %mklibname %{name} -d

%define bootstrap 0
%{?_without_bootstrap: %global bootstrap 0}
%{?_with_bootstrap: %global bootstrap 1}

Summary:	JPEG-2000 utilities
Name:		jasper
Version:	1.900.1
Release:	16
License:	BSD-like
Group:		Graphics
URL:		http://www.ece.uvic.ca/~mdadams/jasper/
Source0: 	http://www.ece.uvic.ca/~mdadams/jasper/software/jasper-%{version}.zip
Patch1: jasper-1.701.0-GL.patch
# autoconf/automake bits of patch1
Patch2: jasper-1.701.0-GL-ac.patch
# CVE-2007-2721 (bug #240397)
# borrowed from http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=413041;msg=88
Patch3: patch-libjasper-stepsizes-overflow.diff
# borrowed from http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=469786 
Patch4: jpc_dec.c.patch
# OpenBSD hardening patches addressing couple of possible integer overflows
# during the memory allocations
# https://bugzilla.redhat.com/show_bug.cgi?id=CVE-2008-3520
Patch5: jasper-1.900.1-CVE-2008-3520.patch
# https://bugzilla.redhat.com/show_bug.cgi?id=CVE-2008-3522
Patch6: jasper-1.900.1-CVE-2008-3522.patch
# add pkg-config support
Patch7: jasper-pkgconfig.patch

Patch8: jasper-1.900.1-CVE-2011-4516-CVE-2011-4517-CERT-VU-887409.patch

# Issues found by static analysis of code
Patch10: jasper-1.900.1-Coverity-BAD_SIZEOF.patch
Patch11: jasper-1.900.1-Coverity-CHECKED_RETURN.patch
Patch12: jasper-1.900.1-Coverity-FORWARD_NULL.patch
Patch13: jasper-1.900.1-Coverity-NULL_RETURNS.patch
Patch14: jasper-1.900.1-Coverity-RESOURCE_LEAK.patch
Patch15: jasper-1.900.1-Coverity-UNREACHABLE.patch
Patch16: jasper-1.900.1-Coverity-UNUSED_VALUE.patch

BuildRequires:	jpeg-devel
BuildRequires:	autoconf automake libtool
%if !%bootstrap
BuildRequires:	mesaglut-devel
%endif

%description
JasPer is a software-based implementation of the codec specified in the
emerging JPEG-2000 Part-1 standard (i.e., ISO/IEC 15444-1).  This package
contains tools for working with JPEG-2000 images.

%package -n	%{libname}
Summary:	Libraries for JasPer
Group:		System/Libraries

%description -n	%{libname}
JasPer is a software-based implementation of the codec specified in the
emerging JPEG-2000 Part-1 standard (i.e., ISO/IEC 15444-1).  This package
contains libraries for working with JPEG-2000 images.

%package -n	%{develname}
Summary:	Development tools for programs which will use the libjasper library
Group:		Development/C
Requires:	%{libname} >= %{version}-%{release}
Provides:	lib%{name}-devel = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Conflicts:	lib64jasper1.701_1-devel
Obsoletes:	%{mklibname %{name} 1 -d} < 1.900.1-5
Provides:	%{mklibname %{name} 1 -d} = %{version}-%{release}

%description -n	%{develname}
The %{libname}-devel package includes the header files necessary for 
developing programs which will manipulate JPEG-2000 files using
the libjasper library.

If you are going to develop programs which will manipulate JPEG-2000 images,
you should install %{libname}-devel.  You'll also need to have the
%{libname} package installed.

%prep

%setup -q
%patch1 -p1 -b .GL
%patch2 -p1 -b .GL-ac
%patch3 -p1 -b .CVE-2007-2721
%patch4 -p1 -b .jpc_dec_assertion
%patch5 -p1 -b .CVE-2008-3520
%patch6 -p1 -b .CVE-2008-3522
%patch7 -p1 -b .pkgconfig
%patch8 -p1 -b .CVE-2011-4516-4517

%patch10 -p1 -b .BAD_SIZEOF
%patch11 -p1 -b .CHECKED_RETURN
%patch12 -p1 -b .FORWARD_NULL
%patch13 -p1 -b .NULL_RETURNS
%patch14 -p1 -b .RESOURCE_LEAK
%patch15 -p1 -b .UNREACHABLE
%patch16 -p1 -b .UNUSED_VALUE

%{__mv} doc/README doc/README.pdf

%build
autoreconf -fi

%configure2_5x \
    --enable-shared \
    --disable-static
%make

%install
%{__rm} -rf %{buildroot}

%makeinstall_std

%multiarch_includes %{buildroot}%{_includedir}/jasper/jas_config.h

# cleanup
rm -f %{buildroot}%{_libdir}/*.*a

%files
%doc README LICENSE NEWS
%{_bindir}/imgcmp
%{_bindir}/imginfo
%{_bindir}/jasper
%if !%bootstrap
%{_bindir}/jiv
%endif
%{_bindir}/tmrdemo
%{_mandir}/man1/imgcmp.1*
%{_mandir}/man1/imginfo.1*
%{_mandir}/man1/jasper.1*
%{_mandir}/man1/jiv.1*

%files -n %{libname}
%{_libdir}/lib*.so.%{major}*

%files -n %{develname}
%doc doc/README.pdf doc/jasper.pdf doc/jpeg2000.pdf
%dir %{_includedir}/%{name}
%dir %{multiarch_includedir}/%{name}
%{multiarch_includedir}/%{name}/*.h
%{_includedir}/%{name}/*
%{_libdir}/*.so
%{_libdir}/pkgconfig/jasper.pc


%changelog
* Fri Dec 16 2011 Oden Eriksson <oeriksson@mandriva.com> 1.900.1-16
+ Revision: 742028
- P8: security fixes for CVE-2011-4516, CVE-2011-4517 (CERT VU#887409)
- P10 - P16: fixes various errors found by static analysis of code (coverity)
- P3, P4, P5, P6 now replaces the ubuntu patch (P0) which fixed the same
  issues (CVE-2007-2721, CVE-2008-3520, CVE-2008-3521, CVE-2008-3522)

* Sat Dec 10 2011 Zé <ze@mandriva.org> 1.900.1-15
+ Revision: 740106
+ rebuild (emptylog)

* Sat Dec 10 2011 Zé <ze@mandriva.org> 1.900.1-14
+ Revision: 740012
- clean static files
- clean provide (already exist by default)

* Fri Dec 02 2011 Oden Eriksson <oeriksson@mandriva.com> 1.900.1-13
+ Revision: 737250
- various cleanups

* Mon May 02 2011 Oden Eriksson <oeriksson@mandriva.com> 1.900.1-12
+ Revision: 661673
- multiarch fixes

* Fri Dec 03 2010 Oden Eriksson <oeriksson@mandriva.com> 1.900.1-11mdv2011.0
+ Revision: 606067
- rebuild

* Tue May 18 2010 Christophe Fergeau <cfergeau@mandriva.com> 1.900.1-10mdv2010.1
+ Revision: 545157
- rebuild to fix perms on debug package (bug #57758)

* Sun Jan 10 2010 Oden Eriksson <oeriksson@mandriva.com> 1.900.1-9mdv2010.1
+ Revision: 488769
- rebuilt against libjpeg v8

* Fri Sep 25 2009 Olivier Blin <blino@mandriva.org> 1.900.1-8mdv2010.0
+ Revision: 449123
- add bootstrap flag to build without mesaglut (from Arnaud Patard)

* Sat Aug 15 2009 Oden Eriksson <oeriksson@mandriva.com> 1.900.1-7mdv2010.0
+ Revision: 416521
- rebuilt against libjpeg v7

* Fri Jun 26 2009 Oden Eriksson <oeriksson@mandriva.com> 1.900.1-6mdv2010.0
+ Revision: 389545
- P0: security fixes for CVE-2007-2721, CVE-2008-3520, CVE-2008-3521, CVE-2008-3522

* Sun Jan 25 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 1.900.1-5mdv2009.1
+ Revision: 333536
- new devel library policy
- spec file clean

* Tue Jun 17 2008 Thierry Vignaud <tv@mandriva.org> 1.900.1-4mdv2009.0
+ Revision: 221674
- rebuild
- fix no-buildroot-tag

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Sun Jan 13 2008 Thierry Vignaud <tv@mandriva.org> 1.900.1-3mdv2008.1
+ Revision: 150417
- rebuild
- kill re-definition of %%buildroot on Pixel's request

* Thu May 10 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 1.900.1-2mdv2008.0
+ Revision: 26012
- Put needed conflicts for older libjasper devel/static-devel packages.

* Fri May 04 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 1.900.1-1mdv2008.0
+ Revision: 22519
- Updated to 1.900.1.
- Cleanups, small typo fixes.


* Mon Mar 19 2007 Thierry Vignaud <tvignaud@mandriva.com> 1.701.0-6mdv2007.1
+ Revision: 146605
- move devel doc in -devel

  + Olivier Blin <oblin@mandriva.com>
    - Import jasper

* Sat Aug 19 2006 Emmanuel Andry <eandry@mandriva.org> 1.701.0-5mdv2007.0
- fix buildrequires
- %%mkrel

* Sat Dec 31 2005 Mandriva Linux Team <http://www.mandrivaexpert.com/> 1.701.0-4mdk
- Rebuild

* Wed Feb 09 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.701.0-3mdk
- multiarch

* Thu Jul 15 2004 Michael Scherer <misc@mandrake.org> 1.701.0-2mdk 
- rebuild for new gcc

